Index: src/org/python/core/PyString.java
===================================================================
--- src/org/python/core/PyString.java	(revision 3110)
+++ src/org/python/core/PyString.java	(working copy)
@@ -1620,24 +1620,12 @@
             }
 
             public PyObject __call__(PyObject arg0) {
-                String result=self.str_join(arg0);
-                //XXX: do we really need to check self?
-                if (self instanceof PyUnicode||arg0 instanceof PyUnicode) {
-                    return new PyUnicode(result);
-                } else {
-                    return new PyString(result);
-                }
+                return self.str_join(arg0);
             }
 
             public PyObject inst_call(PyObject gself,PyObject arg0) {
                 PyString self=(PyString)gself;
-                String result=self.str_join(arg0);
-                //XXX: do we really need to check self?
-                if (self instanceof PyUnicode||arg0 instanceof PyUnicode) {
-                    return new PyUnicode(result);
-                } else {
-                    return new PyString(result);
-                }
+                return self.str_join(arg0);
             }
 
         }
@@ -1802,17 +1790,13 @@
 
             public PyObject __call__(PyObject arg0,PyObject arg1,PyObject arg2) {
                 try {
-                    return new PyString(self.str_replace(arg0.asString(0),arg1.asString(1),arg2.asInt(2)));
+                    return self.str_replace(arg0,arg1,arg2.asInt(2));
                 } catch (PyObject.ConversionException e) {
                     String msg;
                     switch (e.index) {
                     case 2:
                         msg="expected an integer";
                         break;
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
                     default:
                         msg="xxx";
                     }
@@ -1823,17 +1807,13 @@
             public PyObject inst_call(PyObject gself,PyObject arg0,PyObject arg1,PyObject arg2) {
                 PyString self=(PyString)gself;
                 try {
-                    return new PyString(self.str_replace(arg0.asString(0),arg1.asString(1),arg2.asInt(2)));
+                    return self.str_replace(arg0,arg1,arg2.asInt(2));
                 } catch (PyObject.ConversionException e) {
                     String msg;
                     switch (e.index) {
                     case 2:
                         msg="expected an integer";
                         break;
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
                     default:
                         msg="xxx";
                     }
@@ -1842,38 +1822,12 @@
             }
 
             public PyObject __call__(PyObject arg0,PyObject arg1) {
-                try {
-                    return new PyString(self.str_replace(arg0.asString(0),arg1.asString(1)));
-                } catch (PyObject.ConversionException e) {
-                    String msg;
-                    switch (e.index) {
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
-                    default:
-                        msg="xxx";
-                    }
-                    throw Py.TypeError(msg);
-                }
+                return self.str_replace(arg0,arg1);
             }
 
             public PyObject inst_call(PyObject gself,PyObject arg0,PyObject arg1) {
                 PyString self=(PyString)gself;
-                try {
-                    return new PyString(self.str_replace(arg0.asString(0),arg1.asString(1)));
-                } catch (PyObject.ConversionException e) {
-                    String msg;
-                    switch (e.index) {
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
-                    default:
-                        msg="xxx";
-                    }
-                    throw Py.TypeError(msg);
-                }
+                return self.str_replace(arg0,arg1);
             }
 
         }
@@ -4289,42 +4243,54 @@
         return first.concat(string.substring(1).toLowerCase());
     }
 
-    public String replace(String oldPiece, String newPiece) {
+    public PyString replace(PyObject oldPiece, PyObject newPiece) {
         return str_replace(oldPiece, newPiece);
     }
 
-    final String str_replace(String oldPiece, String newPiece) {
+    final PyString str_replace(PyObject oldPiece, PyObject newPiece) {
         return str_replace(oldPiece, newPiece, string.length());
     }
 
-    public String replace(String oldPiece, String newPiece, int maxsplit) {
+    public PyString replace(PyObject oldPiece, PyObject newPiece, int maxsplit) {
         return str_replace(oldPiece, newPiece, maxsplit);
     }
 
-    final String str_replace(String oldPiece, String newPiece, int maxsplit) {
-        PyString newstr = createInstance(newPiece);
-        return newstr.join(split(oldPiece, maxsplit));
+    final PyString str_replace(PyObject oldPiece, PyObject newPiece, int maxsplit) {
+    	if (!(oldPiece instanceof PyString)) {
+            throw Py.TypeError("expected string, " + oldPiece.safeRepr() + " found");
+    	} else if (!(newPiece instanceof PyString)) {
+            throw Py.TypeError("expected string, " + newPiece.safeRepr() + " found");
+    	}
+    	return ((PyString)newPiece).join(split(oldPiece.toString(), maxsplit));
     }
 
-    public String join(PyObject seq) {
+    public PyString join(PyObject seq) {
         return str_join(seq);
     }
 
-    final String str_join(PyObject seq) {
+    final PyString str_join(PyObject seq) {
         StringBuffer buf = new StringBuffer();
 
         PyObject iter = seq.__iter__();
         PyObject obj = null;
+        boolean needUnicode = false;
         for (int i = 0; (obj = iter.__iternext__()) != null; i++) {
-            if (!(obj instanceof PyString))
+            if (!(obj instanceof PyString)) {
                  throw Py.TypeError(
                         "sequence item " + i + ": expected string, " +
                         obj.safeRepr() + " found");
-            if (i > 0)
+            } else if (obj instanceof PyUnicode) {
+            	needUnicode = true;
+        	}	
+            if (i > 0) {
                 buf.append(string);
+            }
             buf.append(obj.__str__());
         }
-        return buf.toString();
+        // "this instanceof PyUnicode" needed because replace uses this method
+        if (needUnicode || this instanceof PyUnicode) 
+        	return new PyUnicode(buf.toString());
+        return new PyString(buf.toString());
     }
 
 
Index: src/org/python/core/PyUnicode.java
===================================================================
--- src/org/python/core/PyUnicode.java	(revision 3110)
+++ src/org/python/core/PyUnicode.java	(working copy)
@@ -1737,17 +1737,13 @@
 
             public PyObject __call__(PyObject arg0,PyObject arg1,PyObject arg2) {
                 try {
-                    return new PyUnicode(self.unicode_replace(arg0.asString(0),arg1.asString(1),arg2.asInt(2)));
+                    return new PyUnicode(self.unicode_replace(arg0,arg1,arg2.asInt(2)));
                 } catch (PyObject.ConversionException e) {
                     String msg;
                     switch (e.index) {
                     case 2:
                         msg="expected an integer";
                         break;
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
                     default:
                         msg="xxx";
                     }
@@ -1758,17 +1754,13 @@
             public PyObject inst_call(PyObject gself,PyObject arg0,PyObject arg1,PyObject arg2) {
                 PyUnicode self=(PyUnicode)gself;
                 try {
-                    return new PyUnicode(self.unicode_replace(arg0.asString(0),arg1.asString(1),arg2.asInt(2)));
+                    return new PyUnicode(self.unicode_replace(arg0,arg1,arg2.asInt(2)));
                 } catch (PyObject.ConversionException e) {
                     String msg;
                     switch (e.index) {
                     case 2:
                         msg="expected an integer";
                         break;
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
                     default:
                         msg="xxx";
                     }
@@ -1777,38 +1769,12 @@
             }
 
             public PyObject __call__(PyObject arg0,PyObject arg1) {
-                try {
-                    return new PyUnicode(self.unicode_replace(arg0.asString(0),arg1.asString(1)));
-                } catch (PyObject.ConversionException e) {
-                    String msg;
-                    switch (e.index) {
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
-                    default:
-                        msg="xxx";
-                    }
-                    throw Py.TypeError(msg);
-                }
+                return new PyUnicode(self.unicode_replace(arg0,arg1));
             }
 
             public PyObject inst_call(PyObject gself,PyObject arg0,PyObject arg1) {
                 PyUnicode self=(PyUnicode)gself;
-                try {
-                    return new PyUnicode(self.unicode_replace(arg0.asString(0),arg1.asString(1)));
-                } catch (PyObject.ConversionException e) {
-                    String msg;
-                    switch (e.index) {
-                    case 0:
-                    case 1:
-                        msg="expected a string";
-                        break;
-                    default:
-                        msg="xxx";
-                    }
-                    throw Py.TypeError(msg);
-                }
+                return new PyUnicode(self.unicode_replace(arg0,arg1));
             }
 
         }
@@ -2946,15 +2912,15 @@
         return str_capitalize();
     }
 
-    final String unicode_replace(String oldPiece, String newPiece) {
+    final PyString unicode_replace(PyObject oldPiece, PyObject newPiece) {
         return str_replace(oldPiece, newPiece);
     }
 
-    final String unicode_replace(String oldPiece, String newPiece, int maxsplit) {
+    final PyString unicode_replace(PyObject oldPiece, PyObject newPiece, int maxsplit) {
         return str_replace(oldPiece, newPiece, maxsplit);
     }
 
-    final String unicode_join(PyObject seq) {
+    final PyString unicode_join(PyObject seq) {
         return str_join(seq);
     }
 
Index: src/templates/unicode.expose
===================================================================
--- src/templates/unicode.expose	(revision 3110)
+++ src/templates/unicode.expose	(working copy)
@@ -40,7 +40,7 @@
 expose_meth: :u ljust i
 expose_meth: :u lower
 expose_meth: :u lstrip S?
-expose_meth: :u replace s s i?
+expose_meth: :u replace o o i?
 expose_meth: :i rfind s i? i?
 expose_meth: :i rindex s i? i?
 expose_meth: :u rjust i
Index: src/templates/str.expose
===================================================================
--- src/templates/str.expose	(revision 3110)
+++ src/templates/str.expose	(working copy)
@@ -38,18 +38,11 @@
 expose_meth: :b istitle
 expose_meth: :b isunicode
 expose_meth: :b isupper
-expose_meth: join o
-    String result = self.str_join(arg0);
-    //XXX: do we really need to check self?
-    if (self instanceof PyUnicode || arg0 instanceof PyUnicode) {
-        return new PyUnicode(result);
-    } else {
-        return new PyString(result);
-    }
+expose_meth: :o join o
 expose_meth: :s ljust i
 expose_meth: :s lower
 expose_meth: :s lstrip S?
-expose_meth: :s replace s s i?
+expose_meth: :o replace o o i?
 expose_meth: :i rfind s i? i?
 expose_meth: :i rindex s i? i?
 expose_meth: :s rjust i

 	  	 
